/* Copyright (c) 1990 by Carrick Sean Casey. */
/* For copying and distribution information, see the file COPYING. */

#include "fn.h"
#include "externs.h"

STRLIST *bufhead = NULL, *buftail = NULL;
int bufmessages = 0;

c_replay(TARGLIST)
TARGDEFS
{
	static char *usage = "usage: c_replay [lines]";
	int lines;

	if (argc > 2)
		TRETURNERR(usage)

	if (argc == 1)
		lines = bufmessages;
	else if (argc == 2)
		lines = atoi(argv[1]);

	if (lines == 0)
		TRETURNERR("c_replay: lines must be greater than zero")
	bufferlist(lines);
	return(TCL_OK);
}


/* add a line of text to the replay buffer */

bufferadd(text)
char *text;
{
	STRLIST *bp;
	int len;

	len = strlen(text);

	/* add this line to the buffer */
	if ((bp = strmakenode(len)) == NULL) {
		putl("fn: not enough memory for buffer", PL_SCR);
	}
	bcopy(text, bp->str, len+1);
	strlinktail(bp, &bufhead, &buftail);

	/* delete entries as necessary to get buffer down to size */
	if (++bufmessages > gv.bufferlines)
		while (bufmessages > gv.bufferlines) {
			bp = bufhead;
			strunlink(bp, &bufhead, &buftail);
			free(bp);
			bufmessages--;
		}
}


/* list some or all of the replay buffer */

bufferlist(lines)
int lines;
{
	STRLIST *bp;

	/* user may want to interrupt this command */
	continued = 0;

	if (!bufmessages)
		putl("[There are no lines in the buffer]", PL_SCR);
	if (lines > bufmessages)
		lines = bufmessages;
	sprintf(mbuf, "[Replaying last %d messages]", lines);
	putl(mbuf, PL_SCR);

	/* find the start point */
	for (bp = buftail; bp->prev && lines; bp = bp->prev, lines--);

	/* print the lines */
	for(; bp && !continued; bp = bp->next)
		putl(bp->str, PL_SCR);

	continued = 0;
	putl("[End of review buffer]", PL_SCR);
}
