/* Copyright (c) 1990 by Carrick Sean Casey. */
/* For copying and distribution information, see the file COPYING. */

/* signal handling routines */

#include "fn.h"
#include "externs.h"
#include <signal.h>

/* Note that some of these routines set "continue" to 1. Continue is used */
/* by a few other fn routines to see if they've been interrupted */

/* The signal stuff is not portable, and should be in unix.c. */

#define	mask(s)	(1 << ((s)-1))

/* set up the signal trappers */

trapsignals()
{
	int askquit(), suspend(), fnexit();

	/* exit on a hangup or terminate signal */
	signal(SIGHUP, fnexit);
	signal(SIGTERM, fnexit);

	/* on an interrupt, verify the user wants to quit */
	signal(SIGINT, askquit);

	/* suspend on a stop signal */
	signal(SIGTSTP, suspend);
}


/* handle a stop signal */
/* this technique is something I learned from some other software */
/* someday I need to learn just why it works */

suspend()
{
	restoreterm();
	signal(SIGTSTP, SIG_DFL);
	sigsetmask(sigblock(0) &~ mask(SIGTSTP));
	kill(0, SIGTSTP);
	sigblock(mask(SIGTSTP));
	signal(SIGTSTP, suspend);
	fnterm();
	continued = 1;
}


/* verify that the user wants to quit */

askquit()
{
	int c;
	static char out[3] = { '\0', '\r', '\n' };

	signal(SIGINT, SIG_IGN);
	write(1, "\rReally Quit? ", 14);
	if ((c = getchar()) == EOF)
		fnexit();
	else {
		out[0] = c;
		write(1, out, 3);
		if (c == 'Y' || c == 'y')
			fnexit();
		else {
			signal(SIGINT, askquit);
			continued = 1;
		}
	}
}
